/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of RabbitMQ.xs. Do not edit this file, edit RabbitMQ.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "RabbitMQ.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "amqp.h"
#include "amqp_private.h"
#include "amqp_framing.h"

typedef amqp_connection_state_t Net__RabbitMQ;

#define int_from_hv(hv,name) \
 do { SV **v; if(NULL != (v = hv_fetch(hv, #name, strlen(#name), 0))) name = SvIV(*v); } while(0)
#define double_from_hv(hv,name) \
 do { SV **v; if(NULL != (v = hv_fetch(hv, #name, strlen(#name), 0))) name = SvNV(*v); } while(0)
#define str_from_hv(hv,name) \
 do { SV **v; if(NULL != (v = hv_fetch(hv, #name, strlen(#name), 0))) name = SvPV_nolen(*v); } while(0)

void die_on_error(pTHX_ int x, char const *context) {
  if (x < 0) {
    Perl_croak(aTHX_ "%s: %s\n", context, strerror(-x));
  }
}

void die_on_amqp_error(pTHX_ amqp_rpc_reply_t x, char const *context) {
  switch (x.reply_type) {
    case AMQP_RESPONSE_NORMAL:
      return;

    case AMQP_RESPONSE_NONE:
      Perl_croak(aTHX_ "%s: missing RPC reply type!", context);
      break;

    case AMQP_RESPONSE_LIBRARY_EXCEPTION:
      Perl_croak(aTHX_ "%s: %s\n", context,
              x.library_errno ? strerror(x.library_errno) : "(end-of-stream)");
      break;

    case AMQP_RESPONSE_SERVER_EXCEPTION:
      switch (x.reply.id) {
        case AMQP_CONNECTION_CLOSE_METHOD: {
          amqp_connection_close_t *m = (amqp_connection_close_t *) x.reply.decoded;
          Perl_croak(aTHX_ "%s: server connection error %d, message: %.*s",
                  context,
                  m->reply_code,
                  (int) m->reply_text.len, (char *) m->reply_text.bytes);
          break;
        }
        case AMQP_CHANNEL_CLOSE_METHOD: {
          amqp_channel_close_t *m = (amqp_channel_close_t *) x.reply.decoded;
          Perl_croak(aTHX_ "%s: server channel error %d, message: %.*s",
                  context,
                  m->reply_code,
                  (int) m->reply_text.len, (char *) m->reply_text.bytes);
          break;
        }
        default:
          Perl_croak(aTHX_ "%s: unknown server error, method id 0x%08X", context, x.reply.id);
          break;
      }
      break;
  }
}

static void
internal_brcb(amqp_channel_t channel, amqp_basic_return_t *m, void *vsv) {
  HV *mp;
  SV *sv = (SV *)vsv;
  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSViv(channel)));
  mp = newHV();
  hv_store(mp, "reply_code", strlen("reply_code"), newSViv(m->reply_code), 0);
  hv_store(mp, "reply_text", strlen("reply_text"),
           newSVpvn(m->reply_text.bytes, m->reply_text.len), 0);
  hv_store(mp, "exchange", strlen("exchange"),
           newSVpvn(m->exchange.bytes, m->exchange.len), 0);
  hv_store(mp, "routing_key", strlen("routing_key"),
           newSVpvn(m->routing_key.bytes, m->routing_key.len), 0);
  XPUSHs(sv_2mortal((SV *)newRV((SV *)mp)));
  PUTBACK;
  call_sv(sv, G_DISCARD);
  SPAGAIN;
  PUTBACK;
  FREETMPS;
  LEAVE;
}
int internal_recv(HV *RETVAL, amqp_connection_state_t conn, int piggyback) {
  amqp_frame_t frame;
  amqp_basic_deliver_t *d;
  amqp_basic_properties_t *p;
  size_t body_target;
  size_t body_received;
  int result;

  result = 0;
  while (1) {
    SV *payload;

    if(!piggyback) {
      amqp_maybe_release_buffers(conn);
      result = amqp_simple_wait_frame(conn, &frame);
      if (result <= 0) break;
      if (frame.frame_type == AMQP_FRAME_HEARTBEAT) {
        hv_store(RETVAL, "frame_type", strlen("frame_type"), newSVpv((const char *)"heartbeat", 0), 0);
        return result;
      }
      if (frame.frame_type != AMQP_FRAME_METHOD) continue;
      if (frame.payload.method.id != AMQP_BASIC_DELIVER_METHOD) continue;
      d = (amqp_basic_deliver_t *) frame.payload.method.decoded;
      hv_store(RETVAL, "delivery_tag", strlen("delivery_tag"), newSVpvn((const char *)&d->delivery_tag, sizeof(d->delivery_tag)), 0);
      hv_store(RETVAL, "exchange", strlen("exchange"), newSVpvn(d->exchange.bytes, d->exchange.len), 0);
      hv_store(RETVAL, "consumer_tag", strlen("consumer_tag"), newSVpvn(d->consumer_tag.bytes, d->consumer_tag.len), 0);
      hv_store(RETVAL, "routing_key", strlen("routing_key"), newSVpvn(d->routing_key.bytes, d->routing_key.len), 0);
      piggyback = 0;
    }

    result = amqp_simple_wait_frame(conn, &frame);
    if (frame.frame_type == AMQP_FRAME_HEARTBEAT) {
      hv_store(RETVAL, "frame_type", strlen("frame_type"), newSVpv((const char *)"heartbeat", 0), 0);
      return result;
    }
    if (result <= 0) break;

    if (frame.frame_type != AMQP_FRAME_HEADER)
      Perl_croak(aTHX_ "Unexpected header %d!", frame.frame_type);

    HV *props;
    props = newHV();
    hv_store(RETVAL, "props", strlen("props"), newRV_noinc((SV *)props), 0);

    p = (amqp_basic_properties_t *) frame.payload.properties.decoded;
    if (p->_flags & AMQP_BASIC_CONTENT_TYPE_FLAG) {
      hv_store(props, "content_type", strlen("content_type"),
               newSVpvn(p->content_type.bytes, p->content_type.len), 0);
    }
    if (p->_flags & AMQP_BASIC_CONTENT_ENCODING_FLAG) {
      hv_store(props, "content_encoding", strlen("content_encoding"),
               newSVpvn(p->content_encoding.bytes, p->content_encoding.len), 0);
    }
    if (p->_flags & AMQP_BASIC_CORRELATION_ID_FLAG) {
      hv_store(props, "correlation_id", strlen("correlation_id"),
               newSVpvn(p->correlation_id.bytes, p->correlation_id.len), 0);
    }
    if (p->_flags & AMQP_BASIC_REPLY_TO_FLAG) {
      hv_store(props, "reply_to", strlen("reply_to"),
               newSVpvn(p->reply_to.bytes, p->reply_to.len), 0);
    }
    if (p->_flags & AMQP_BASIC_EXPIRATION_FLAG) {
      hv_store(props, "expiration", strlen("expiration"),
               newSVpvn(p->expiration.bytes, p->expiration.len), 0);
    }
    if (p->_flags & AMQP_BASIC_MESSAGE_ID_FLAG) {
      hv_store(props, "message_id", strlen("message_id"),
               newSVpvn(p->message_id.bytes, p->message_id.len), 0);
    }
    if (p->_flags & AMQP_BASIC_TYPE_FLAG) {
      hv_store(props, "type", strlen("type"),
               newSVpvn(p->type.bytes, p->type.len), 0);
    }
    if (p->_flags & AMQP_BASIC_USER_ID_FLAG) {
      hv_store(props, "user_id", strlen("user_id"),
               newSVpvn(p->user_id.bytes, p->user_id.len), 0);
    }
    if (p->_flags & AMQP_BASIC_APP_ID_FLAG) {
      hv_store(props, "app_id", strlen("app_id"),
               newSVpvn(p->app_id.bytes, p->app_id.len), 0);
    }
    if (p->_flags & AMQP_BASIC_DELIVERY_MODE_FLAG) {
      hv_store(props, "delivery_mode", strlen("delivery_mode"),
               newSViv(p->delivery_mode), 0);
    }
    if (p->_flags & AMQP_BASIC_PRIORITY_FLAG) {
      hv_store(props, "priority", strlen("priority"),
               newSViv(p->priority), 0);
    }
    if (p->_flags & AMQP_BASIC_TIMESTAMP_FLAG) {
      hv_store(props, "timestamp", strlen("timestamp"),
               newSViv(p->timestamp), 0);
    }

    if (p->_flags & AMQP_BASIC_HEADERS_FLAG) {
      int i;
      SV *val;
      HV *headers = newHV();
      hv_store( props, "headers", strlen("headers"), newRV_noinc((SV *)headers), 0 );

      for( i=0; i < p->headers.num_entries; ++i ) {
        if( p->headers.entries[i].kind == 'I' ) {
          hv_store( headers,
              p->headers.entries[i].key.bytes, p->headers.entries[i].key.len,
              newSViv(p->headers.entries[i].value.i32),
              0
          );
        }
        else if( p->headers.entries[i].kind == 'S' ) {
          hv_store( headers,
              p->headers.entries[i].key.bytes, p->headers.entries[i].key.len,
              newSVpvn( p->headers.entries[i].value.bytes.bytes, p->headers.entries[i].value.bytes.len),
              0
          );
        }
        else if( p->headers.entries[i].kind == 't' ) {
          hv_store( headers,
              p->headers.entries[i].key.bytes, p->headers.entries[i].key.len,
              newSViv(p->headers.entries[i].value.boolean),
              0
          );
        }
	else {
	    Perl_croak(aTHX_ "Unhandled AMQP type '%c'", p->headers.entries[i].kind == 't');
	}
      }
    }

    body_target = frame.payload.properties.body_size;
    body_received = 0;
    payload = newSVpvn("", 0);

    while (body_received < body_target) {
      result = amqp_simple_wait_frame(conn, &frame);
      if (result <= 0) break;

      if (frame.frame_type != AMQP_FRAME_BODY) {
        Perl_croak(aTHX_ "Expected fram body, got %d!", frame.frame_type);
      }

      body_received += frame.payload.body_fragment.len;
      assert(body_received <= body_target);

      sv_catpvn(payload, frame.payload.body_fragment.bytes, frame.payload.body_fragment.len);
    }

    if (body_received != body_target) {
      /* Can only happen when amqp_simple_wait_frame returns <= 0 */
      /* We break here to close the connection */
      Perl_croak(aTHX_ "Short read %llu != %llu", (long long unsigned int)body_received, (long long unsigned int)body_target);
    }
    hv_store(RETVAL, "body", strlen("body"), payload, 0);
    break;
  }
  return result;
}

void hash_to_amqp_table(amqp_connection_state_t conn, HV *hash, amqp_table_t *table) {
  HE   *he;
  char *key;
  SV   *value;
  I32  retlen;

  amqp_create_table(conn, table, HvKEYS(hash));

  hv_iterinit(hash);
  while (NULL != (he = hv_iternext(hash))) {
    key = hv_iterkey(he, &retlen);
    value = hv_iterval(hash, he);

    if (SvGMAGICAL(value))
      mg_get(value);

    if (SvPOK(value)) {
      amqp_table_add_string(conn, table, amqp_cstring_bytes(key), amqp_cstring_bytes(SvPV_nolen(value)));
    } else if (SvIOK(value)) {
      amqp_table_add_int(conn, table, amqp_cstring_bytes(key), (uint64_t) SvIV(value));
    } else {
      Perl_croak( aTHX_ "Unsupported SvType for hash value: %d", SvTYPE(value) );
    }
  }
}

#line 282 "RabbitMQ.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 426 "RabbitMQ.c"

XS_EUPXS(XS_Net__RabbitMQ_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_connect)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "conn, hostname, options");
    {
	Net__RabbitMQ	conn;
	char *	hostname = (char *)SvPV_nolen(ST(1))
;
	HV *	options;
#line 283 "RabbitMQ.xs"
    int sockfd;
    char *user = "guest";
    char *password = "guest";
    char *vhost = "/";
    int port = 5672;
    int channel_max = 0;
    int frame_max = 131072;
    int heartbeat = 0;
    double timeout = -1;
    struct timeval to;
#line 450 "RabbitMQ.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::connect",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    options = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::RabbitMQ::connect",
				"options");
		}
	} STMT_END
;
#line 294 "RabbitMQ.xs"
    str_from_hv(options, user);
    str_from_hv(options, password);
    str_from_hv(options, vhost);
    int_from_hv(options, channel_max);
    int_from_hv(options, frame_max);
    int_from_hv(options, heartbeat);
    int_from_hv(options, port);
    double_from_hv(options, timeout);
    if(timeout >= 0) {
     to.tv_sec = floor(timeout);
     to.tv_usec = 1000000.0 * (timeout - floor(timeout));
    }

    die_on_error(aTHX_ sockfd = amqp_open_socket(hostname, port, (timeout<0)?NULL:&to), "Opening socket");
    amqp_set_sockfd(conn, sockfd);
    die_on_amqp_error(aTHX_ amqp_login(conn, vhost, channel_max, frame_max,
                                       heartbeat, AMQP_SASL_METHOD_PLAIN,
                                       user, password),
                      "Logging in");
    RETVAL = sockfd;
#line 502 "RabbitMQ.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_basic_return); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_basic_return)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conn, code");
    {
	Net__RabbitMQ	conn;
	SV *	code = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::basic_return",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 322 "RabbitMQ.xs"
    SvREFCNT_inc(code);
    amqp_set_basic_return_cb(conn, internal_brcb, code);
#line 537 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_channel_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_channel_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conn, channel");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
#line 330 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
#line 555 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::channel_open",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 332 "RabbitMQ.xs"
    amqp_channel_open(conn, channel);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Opening channel");
#line 574 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_channel_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_channel_close)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conn, channel");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::channel_close",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 341 "RabbitMQ.xs"
    die_on_amqp_error(aTHX_ amqp_channel_close(conn, channel, AMQP_REPLY_SUCCESS), "Closing channel");
#line 606 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_exchange_declare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_exchange_declare)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "conn, channel, exchange, options = NULL, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	exchange = (char *)SvPV_nolen(ST(2))
;
	HV *	options;
	HV *	args;
#line 351 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    char *exchange_type = "direct";
    int passive = 0;
    int durable = 0;
    int auto_delete = 1;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 633 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::exchange_declare",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(3);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::exchange_declare",
				    "options");
		    }
	    } STMT_END
;
	}

	if (items < 5)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(4);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::exchange_declare",
				    "args");
		    }
	    } STMT_END
;
	}
#line 358 "RabbitMQ.xs"
    if(options) {
      str_from_hv(options, exchange_type);
      int_from_hv(options, passive);
      int_from_hv(options, durable);
      int_from_hv(options, auto_delete);
    }
    amqp_exchange_declare(conn, channel, amqp_cstring_bytes(exchange), amqp_cstring_bytes(exchange_type),
                          passive, durable, auto_delete, arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Declaring exchange");
#line 695 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_exchange_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_exchange_delete)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, exchange, options = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	exchange = (char *)SvPV_nolen(ST(2))
;
	HV *	options;
#line 376 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    int if_unused = 1;
    int nowait = 0;
#line 718 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::exchange_delete",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(3);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::exchange_delete",
				    "options");
		    }
	    } STMT_END
;
	}
#line 380 "RabbitMQ.xs"
    if(options) {
      int_from_hv(options, if_unused);
      int_from_hv(options, nowait);
    }
    amqp_exchange_delete(conn, channel, amqp_cstring_bytes(exchange), if_unused, nowait);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Deleting exchange");
#line 759 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_queue_declare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_queue_declare)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "conn, channel, queuename, options = NULL, args = NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	HV *	options;
	HV *	args;
#line 396 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    int passive = 0;
    int durable = 0;
    int exclusive = 0;
    int auto_delete = 1;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
    amqp_bytes_t queuename_b = AMQP_EMPTY_BYTES;
#line 789 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::queue_declare",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(3);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::queue_declare",
				    "options");
		    }
	    } STMT_END
;
	}

	if (items < 5)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(4);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::queue_declare",
				    "args");
		    }
	    } STMT_END
;
	}
#line 404 "RabbitMQ.xs"
    if(queuename && strcmp(queuename, "")) queuename_b = amqp_cstring_bytes(queuename);
    if(options) {
      int_from_hv(options, passive);
      int_from_hv(options, durable);
      int_from_hv(options, exclusive);
      int_from_hv(options, auto_delete);
    }
    if(args)
      hash_to_amqp_table(conn, args, &arguments);
    amqp_queue_declare_ok_t *r = amqp_queue_declare(conn, channel, queuename_b, passive,
                                                    durable, exclusive, auto_delete,
                                                    arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Declaring queue");
    XPUSHs(sv_2mortal(newSVpvn(r->queue.bytes, r->queue.len)));
    if(GIMME_V == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVuv(r->message_count)));
      XPUSHs(sv_2mortal(newSVuv(r->consumer_count)));
    }
#line 860 "RabbitMQ.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__RabbitMQ_queue_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_queue_bind)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "conn, channel, queuename, exchange, bindingkey, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	char *	exchange = (char *)SvPV_nolen(ST(3))
;
	char *	bindingkey = (char *)SvPV_nolen(ST(4))
;
	HV *	args;
#line 433 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 887 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::queue_bind",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 6)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(5);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::queue_bind",
				    "args");
		    }
	    } STMT_END
;
	}
#line 436 "RabbitMQ.xs"
    if(queuename == NULL || exchange == NULL)
      Perl_croak(aTHX_ "queuename and exchange must both be specified");
    if(bindingkey == NULL && args == NULL)
      Perl_croak(aTHX_ "bindingkey or args must be specified");
    if(args)
      hash_to_amqp_table(conn, args, &arguments);
    amqp_queue_bind(conn, channel, amqp_cstring_bytes(queuename),
                    amqp_cstring_bytes(exchange),
                    amqp_cstring_bytes(bindingkey),
                    arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Binding queue");
#line 933 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_queue_unbind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_queue_unbind)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "conn, channel, queuename, exchange, bindingkey, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	char *	exchange = (char *)SvPV_nolen(ST(3))
;
	char *	bindingkey = (char *)SvPV_nolen(ST(4))
;
	HV *	args;
#line 458 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 959 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::queue_unbind",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 6)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(5);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::queue_unbind",
				    "args");
		    }
	    } STMT_END
;
	}
#line 461 "RabbitMQ.xs"
    if(queuename == NULL || exchange == NULL)
      Perl_croak(aTHX_ "queuename and exchange must both be specified");
    if(bindingkey == NULL && args == NULL)
      Perl_croak(aTHX_ "bindingkey or args must be specified");
    if(args)
      hash_to_amqp_table(conn, args, &arguments);
    amqp_queue_unbind(conn, channel, amqp_cstring_bytes(queuename),
                      amqp_cstring_bytes(exchange),
                    amqp_cstring_bytes(bindingkey),
                    arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Unbinding queue");
#line 1005 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_consume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_consume)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, queuename, options = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	HV *	options;
#line 481 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_basic_consume_ok_t *r;
    char *consumer_tag = NULL;
    int no_local = 0;
    int no_ack = 1;
    int exclusive = 0;
#line 1031 "RabbitMQ.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::consume",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(3);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::consume",
				    "options");
		    }
	    } STMT_END
;
	}
#line 488 "RabbitMQ.xs"
    if(options) {
      str_from_hv(options, consumer_tag);
      int_from_hv(options, no_local);
      int_from_hv(options, no_ack);
      int_from_hv(options, exclusive);
    }
    r = amqp_basic_consume(conn, channel, amqp_cstring_bytes(queuename),
                           consumer_tag ? amqp_cstring_bytes(consumer_tag) : AMQP_EMPTY_BYTES,
                           no_local, no_ack, exclusive);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Consume queue");
    RETVAL = newSVpvn(r->consumer_tag.bytes, r->consumer_tag.len);
#line 1078 "RabbitMQ.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_recv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
#line 507 "RabbitMQ.xs"
    int result = 0;
#line 1096 "RabbitMQ.c"
	HV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::recv",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 509 "RabbitMQ.xs"
    RETVAL = newHV();
    sv_2mortal((SV*)RETVAL);
    result = internal_recv(RETVAL, conn, 0);
    if(result <= 0) Perl_croak(aTHX_ "Bad frame read.");
#line 1117 "RabbitMQ.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_ack); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_ack)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, delivery_tag, multiple = 0");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	SV *	delivery_tag = ST(2)
;
	int	multiple;
#line 523 "RabbitMQ.xs"
    STRLEN len;
    uint64_t tag;
    unsigned char *l;
#line 1146 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::ack",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    multiple = 0;
	else {
	    multiple = (int)SvIV(ST(3))
;
	}
#line 527 "RabbitMQ.xs"
    l = SvPV(delivery_tag, len);
    if(len != sizeof(tag)) Perl_croak(aTHX_ "bad tag");
    memcpy(&tag, l, sizeof(tag));
    die_on_error(aTHX_ amqp_basic_ack(conn, channel, tag, multiple),
                 "ack");
#line 1174 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_reject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_reject)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, delivery_tag, requeue = 0");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	SV *	delivery_tag = ST(2)
;
	int	requeue;
#line 541 "RabbitMQ.xs"
   STRLEN len;
   uint64_t tag;
   unsigned char *l;
#line 1197 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::reject",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    requeue = 0;
	else {
	    requeue = (int)SvIV(ST(3))
;
	}
#line 545 "RabbitMQ.xs"
   l = SvPV(delivery_tag, len);
   if(len != sizeof(tag)) Perl_croak(aTHX_ "bad tag");
   memcpy(&tag, l, sizeof(tag));
   die_on_error(aTHX_ amqp_basic_reject(conn, channel, tag, requeue),
                "reject");
#line 1225 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_purge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_purge)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, queuename, no_wait = 0");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	int	no_wait;
#line 559 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
#line 1246 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::purge",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    no_wait = 0;
	else {
	    no_wait = (int)SvIV(ST(3))
;
	}
#line 561 "RabbitMQ.xs"
    amqp_queue_purge(conn, channel, amqp_cstring_bytes(queuename), no_wait);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Purging queue");
#line 1272 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ__publish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ__publish)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "conn, channel, routing_key, body, options = NULL, props = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	HV *	options;
	char *	routing_key = (char *)SvPV_nolen(ST(2))
;
	SV *	body = ST(3)
;
	HV *	props;
#line 574 "RabbitMQ.xs"
    SV **v;
    char *exchange = "amq.direct";
    amqp_boolean_t mandatory = 0;
    amqp_boolean_t immediate = 0;
    int rv;
    amqp_bytes_t exchange_b = { 0 };
    amqp_bytes_t routing_key_b;
    amqp_bytes_t body_b;
    struct amqp_basic_properties_t_ properties;
    STRLEN len;
#line 1305 "RabbitMQ.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::_publish",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 5)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(4);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::_publish",
				    "options");
		    }
	    } STMT_END
;
	}

	if (items < 6)
	    props = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(5);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			props = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::_publish",
				    "props");
		    }
	    } STMT_END
;
	}
#line 585 "RabbitMQ.xs"
    routing_key_b = amqp_cstring_bytes(routing_key);
    body_b.bytes = SvPV(body, len);
    body_b.len = len;
    if(options) {
      if(NULL != (v = hv_fetch(options, "mandatory", strlen("mandatory"), 0))) mandatory = SvIV(*v) ? 1 : 0;
      if(NULL != (v = hv_fetch(options, "immediate", strlen("immediate"), 0))) immediate = SvIV(*v) ? 1 : 0;
      if(NULL != (v = hv_fetch(options, "exchange", strlen("exchange"), 0))) exchange_b = amqp_cstring_bytes(SvPV_nolen(*v));
    }
    properties.headers = AMQP_EMPTY_TABLE;
    properties._flags = 0;
    if (props) {
      if (NULL != (v = hv_fetch(props, "content_type", strlen("content_type"), 0))) {
        properties.content_type     = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_CONTENT_TYPE_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "content_encoding", strlen("content_encoding"), 0))) {
        properties.content_encoding = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_CONTENT_ENCODING_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "correlation_id", strlen("correlation_id"), 0))) {
        properties.correlation_id   =  amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_CORRELATION_ID_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "reply_to", strlen("reply_to"), 0))) {
        properties.reply_to         = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_REPLY_TO_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "expiration", strlen("expiration"), 0))) {
        properties.expiration       = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_EXPIRATION_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "message_id", strlen("message_id"), 0))) {
        properties.message_id       = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_MESSAGE_ID_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "type", strlen("type"), 0))) {
        properties.type             = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_TYPE_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "user_id", strlen("user_id"), 0))) {
        properties.user_id          = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_USER_ID_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "app_id", strlen("app_id"), 0))) {
        properties.app_id           = amqp_cstring_bytes(SvPV_nolen(*v));
        properties._flags |= AMQP_BASIC_APP_ID_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "delivery_mode", strlen("delivery_mode"), 0))) {
        properties.delivery_mode    = (uint8_t) SvIV(*v);
        properties._flags |= AMQP_BASIC_DELIVERY_MODE_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "priority", strlen("priority"), 0))) {
        properties.priority         = (uint8_t) SvIV(*v);
        properties._flags |= AMQP_BASIC_PRIORITY_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "timestamp", strlen("timestamp"), 0))) {
        properties.timestamp        = (uint64_t) SvIV(*v);
        properties._flags |= AMQP_BASIC_TIMESTAMP_FLAG;
      }
      if (NULL != (v = hv_fetch(props, "headers", strlen("headers"), 0))) {
        hash_to_amqp_table(conn, (HV *)SvRV(*v), &properties.headers);
        properties._flags |= AMQP_BASIC_HEADERS_FLAG;
      }
    }
    rv = amqp_basic_publish(conn, channel, exchange_b, routing_key_b, mandatory, immediate, &properties, body_b);
    RETVAL = rv;
#line 1425 "RabbitMQ.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_get)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, channel, queuename, options = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	char *	queuename = (char *)SvPV_nolen(ST(2))
;
	HV *	options;
#line 661 "RabbitMQ.xs"
    amqp_rpc_reply_t r;
    int no_ack = 1;
#line 1449 "RabbitMQ.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::get",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    options = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(3);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			options = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::get",
				    "options");
		    }
	    } STMT_END
;
	}
#line 664 "RabbitMQ.xs"
    if(options)
      int_from_hv(options, no_ack);
    amqp_maybe_release_buffers(conn);
    r = amqp_basic_get(conn, channel, queuename ? amqp_cstring_bytes(queuename) : AMQP_EMPTY_BYTES, no_ack);
    die_on_amqp_error(aTHX_ r, "basic_get");
    if(r.reply.id == AMQP_BASIC_GET_OK_METHOD) {
      HV *hv;
      amqp_basic_get_ok_t *ok = (amqp_basic_get_ok_t *)r.reply.decoded;
      hv = newHV();
      hv_store(hv, "delivery_tag", strlen("delivery_tag"), newSVpvn((const char *)&ok->delivery_tag, sizeof(ok->delivery_tag)), 0);
      hv_store(hv, "redelivered", strlen("redelivered"), newSViv(ok->redelivered), 0);
      hv_store(hv, "exchange", strlen("exchange"), newSVpvn(ok->exchange.bytes, ok->exchange.len), 0);
      hv_store(hv, "routing_key", strlen("routing_key"), newSVpvn(ok->routing_key.bytes, ok->routing_key.len), 0);
      hv_store(hv, "message_count", strlen("message_count"), newSViv(ok->message_count), 0);
      if(amqp_data_in_buffer(conn)) {
        int rv;
        rv = internal_recv(hv, conn, 1);
        if(rv <= 0) Perl_croak(aTHX_ "Bad frame read.");
      }
      RETVAL = (SV *)newRV_noinc((SV *)hv);
    }
    else
      RETVAL = &PL_sv_undef;
#line 1507 "RabbitMQ.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_get_channel_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_get_channel_max)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::get_channel_max",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 694 "RabbitMQ.xs"
    RETVAL = amqp_get_channel_max(conn);
#line 1541 "RabbitMQ.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
#line 702 "RabbitMQ.xs"
    int sockfd;
#line 1559 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::disconnect",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 704 "RabbitMQ.xs"
    die_on_amqp_error(aTHX_ amqp_connection_close(conn, AMQP_REPLY_SUCCESS), "Closing connection");
    sockfd = amqp_get_sockfd(conn);
    if(sockfd >= 0) close(sockfd);
    amqp_set_sockfd(conn,-1);
#line 1579 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "clazz");
    {
	char *	clazz = (char *)SvPV_nolen(ST(0))
;
	Net__RabbitMQ	RETVAL;
#line 713 "RabbitMQ.xs"
    RETVAL = amqp_new_connection();
#line 1597 "RabbitMQ.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Net::RabbitMQ", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__RabbitMQ_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
#line 721 "RabbitMQ.xs"
    int sockfd;
#line 1619 "RabbitMQ.c"

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Net::RabbitMQ::DESTROY",
			"conn")
;
#line 723 "RabbitMQ.xs"
    amqp_connection_close(conn, AMQP_REPLY_SUCCESS);
    sockfd = amqp_get_sockfd(conn);
    if(sockfd >= 0) close(sockfd);
    amqp_destroy_connection(conn);
#line 1635 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_heartbeat1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_heartbeat1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
#line 732 "RabbitMQ.xs"
  amqp_frame_t f;
#line 1651 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::heartbeat1",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 734 "RabbitMQ.xs"
    f.frame_type = AMQP_FRAME_HEARTBEAT;
    f.channel = 0;
    amqp_send_frame(conn, &f);
#line 1670 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_heartbeat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_heartbeat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	Net__RabbitMQ	conn;
#line 742 "RabbitMQ.xs"
  amqp_frame_t f;
#line 1686 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::heartbeat",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;
#line 744 "RabbitMQ.xs"
    if(conn->last_send.tv_sec != 0) {
      struct timeval now;
      gettimeofday(&now, NULL);
      long diff = now.tv_sec - conn->last_send.tv_sec;
      diff *= 1000000;
      diff += now.tv_usec - conn->last_send.tv_usec;
      if(diff < 1000000 * conn->heartbeat)
        return;
    }
    f.frame_type = AMQP_FRAME_HEARTBEAT;
    f.channel = 0;
    amqp_send_frame(conn, &f);
#line 1714 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_tx_select); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_tx_select)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, channel, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	HV *	args;
#line 763 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 1734 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::tx_select",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::tx_select",
				    "args");
		    }
	    } STMT_END
;
	}
#line 766 "RabbitMQ.xs"
    amqp_tx_select(conn, channel, arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Selecting transaction");
#line 1771 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_tx_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_tx_commit)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, channel, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	HV *	args;
#line 776 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 1791 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::tx_commit",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::tx_commit",
				    "args");
		    }
	    } STMT_END
;
	}
#line 779 "RabbitMQ.xs"
    amqp_tx_commit(conn, channel, arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Commiting transaction");
#line 1828 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_tx_rollback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_tx_rollback)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, channel, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	HV *	args;
#line 789 "RabbitMQ.xs"
    amqp_rpc_reply_t *amqp_rpc_reply;
    amqp_table_t arguments = AMQP_EMPTY_TABLE;
#line 1848 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::tx_rollback",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::tx_rollback",
				    "args");
		    }
	    } STMT_END
;
	}
#line 792 "RabbitMQ.xs"
    amqp_tx_rollback(conn, channel, arguments);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Rolling Back transaction");
#line 1885 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__RabbitMQ_basic_qos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__RabbitMQ_basic_qos)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, channel, args = NULL");
    {
	Net__RabbitMQ	conn;
	int	channel = (int)SvIV(ST(1))
;
	HV *	args;
#line 802 "RabbitMQ.xs"
    SV **v;
    amqp_rpc_reply_t *amqp_rpc_reply;
    uint32_t prefetch_size = 0;
    uint16_t prefetch_count = 0;
    amqp_boolean_t global = 0;
#line 1908 "RabbitMQ.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Net::RabbitMQ")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    conn = INT2PTR(Net__RabbitMQ,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Net::RabbitMQ::basic_qos",
			"conn", "Net::RabbitMQ",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    args = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			args = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "Net::RabbitMQ::basic_qos",
				    "args");
		    }
	    } STMT_END
;
	}
#line 808 "RabbitMQ.xs"
    if(args) {
      if(NULL != (v = hv_fetch(args, "prefetch_size", strlen("prefetch_size"), 0))) prefetch_size = SvIV(*v);
      if(NULL != (v = hv_fetch(args, "prefetch_count", strlen("prefetch_count"), 0))) prefetch_count = SvIV(*v);
      if(NULL != (v = hv_fetch(args, "global", strlen("global"), 0))) global = SvIV(*v) ? 1 : 0;
    }
    amqp_basic_qos(conn, channel, 
                   prefetch_size, prefetch_count, global);
    amqp_rpc_reply = amqp_get_rpc_reply();
    die_on_amqp_error(aTHX_ *amqp_rpc_reply, "Basic QoS");
#line 1951 "RabbitMQ.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Net__RabbitMQ); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__RabbitMQ)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::RabbitMQ::connect", XS_Net__RabbitMQ_connect);
        newXS_deffile("Net::RabbitMQ::basic_return", XS_Net__RabbitMQ_basic_return);
        newXS_deffile("Net::RabbitMQ::channel_open", XS_Net__RabbitMQ_channel_open);
        newXS_deffile("Net::RabbitMQ::channel_close", XS_Net__RabbitMQ_channel_close);
        newXS_deffile("Net::RabbitMQ::exchange_declare", XS_Net__RabbitMQ_exchange_declare);
        newXS_deffile("Net::RabbitMQ::exchange_delete", XS_Net__RabbitMQ_exchange_delete);
        newXS_deffile("Net::RabbitMQ::queue_declare", XS_Net__RabbitMQ_queue_declare);
        newXS_deffile("Net::RabbitMQ::queue_bind", XS_Net__RabbitMQ_queue_bind);
        newXS_deffile("Net::RabbitMQ::queue_unbind", XS_Net__RabbitMQ_queue_unbind);
        newXS_deffile("Net::RabbitMQ::consume", XS_Net__RabbitMQ_consume);
        newXS_deffile("Net::RabbitMQ::recv", XS_Net__RabbitMQ_recv);
        newXS_deffile("Net::RabbitMQ::ack", XS_Net__RabbitMQ_ack);
        newXS_deffile("Net::RabbitMQ::reject", XS_Net__RabbitMQ_reject);
        newXS_deffile("Net::RabbitMQ::purge", XS_Net__RabbitMQ_purge);
        newXS_deffile("Net::RabbitMQ::_publish", XS_Net__RabbitMQ__publish);
        newXS_deffile("Net::RabbitMQ::get", XS_Net__RabbitMQ_get);
        newXS_deffile("Net::RabbitMQ::get_channel_max", XS_Net__RabbitMQ_get_channel_max);
        newXS_deffile("Net::RabbitMQ::disconnect", XS_Net__RabbitMQ_disconnect);
        newXS_deffile("Net::RabbitMQ::new", XS_Net__RabbitMQ_new);
        newXS_deffile("Net::RabbitMQ::DESTROY", XS_Net__RabbitMQ_DESTROY);
        newXS_deffile("Net::RabbitMQ::heartbeat1", XS_Net__RabbitMQ_heartbeat1);
        newXS_deffile("Net::RabbitMQ::heartbeat", XS_Net__RabbitMQ_heartbeat);
        newXS_deffile("Net::RabbitMQ::tx_select", XS_Net__RabbitMQ_tx_select);
        newXS_deffile("Net::RabbitMQ::tx_commit", XS_Net__RabbitMQ_tx_commit);
        newXS_deffile("Net::RabbitMQ::tx_rollback", XS_Net__RabbitMQ_tx_rollback);
        newXS_deffile("Net::RabbitMQ::basic_qos", XS_Net__RabbitMQ_basic_qos);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
